#include <unistd.h>
#include <pwd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

void usage();

main (int argc, char **argv)
{	int ch;
	struct passwd *pwd;
	char *username, *p, *foo2=NULL,*pass=NULL,*home=malloc(255),*command=malloc(255), *lpass=malloc(255);
	char try[30], *namethingie=malloc(255), foo[255], *foop; 
	FILE *passfile, *npass;
	uid_t uid=getuid();

	if (uid)
	  puts("\t\tONLY ROOT is allowed to modify user attributes ... \n\t\t\t\t\tSiviwe\'s usermod (ver 1.0)\n");

	pwd = getpwnam(argv[argc-1]);
	if (pwd == NULL)  {
	  usage();
	  exit(1);
	}

	if ((passfile=fopen("/etc/passwd","r"))==NULL) {
	  printf("Could not open passwd file\n Write failed !\n");
	  exit(-1);
	}
	if ((npass=fopen("/etc/ptmp","w"))==NULL) {
	  printf("Could not open temp file\n Write failed !\n");
	  exit(-1);
	}

	pass=malloc(255);
	username=malloc(9);
	command[0]='\0';

// HAD to put these 2 lines above here to accomodate the change in username
// ----------------------------------------
  // This is the pointwhere we write to file ...
  // DONT you just *HATE* C ? *grin*
        p=malloc(20);
	foo2=malloc(255);
	sprintf(p,"%s:",pwd->pw_name);
	strcpy(foo2,"");
// ----------------------------------------

	while ((ch=getopt(argc, argv, "f:h:ps:u:l")) != EOF)
	  switch(ch) {
	    case 'f': foo[0]='\0';
		      strcpy(foo,optarg);
		      printf("foo == %s\n",foo);
		      namethingie=strchr(pwd->pw_gecos,',');
		      printf("name == %s\n",namethingie);
		      if (namethingie != NULL) {
			strcat(foo,namethingie);
			printf("here it is : %s\n",foo);
		      }
		      pwd->pw_gecos=foo;
		      break;

	    case 'h': // Get the arg which comes with this ...
		      // WE take no rubbish .. what u give is what u get back ..
		      printf("Moving home-directory from \'%s\' to \'%s\' for USER \'%s\'\n",pwd->pw_dir,optarg,pwd->pw_name);
		      home=optarg;
		      sprintf(command,"mv --verbose %s %s", pwd->pw_dir, home);
		      pwd->pw_dir=home;
		      system(command);
		      break;

	    case 'p': pass = getpass("New Passwd : ");
		      pwd->pw_passwd=crypt(pass,pwd->pw_passwd);
		      break; // Simple nuff for ya ?

	    case 's': // Get the arg which comes with this ...
		      // This is the shell...
	      	      printf("Changing shell for USER \'%s\' to \'%s\'\n",pwd->pw_name,optarg);
		      pwd->pw_shell=optarg;
		      break;

	    case 'u': // Get the arg that comes with this ... 
		      // This is the new username
		      printf("Changing username for USER \'%s\' to \'%s\'\n",pwd->pw_name,optarg);
		      username=optarg;
		      if ((getpwnam(username))==NULL) 
		        pwd->pw_name=username;
		      else {
			printf("Username in use, choose another!");
			exit(-1);
		      }
		      break;
	    case 'l': // Unlock passwd if locked ...
		      lpass=pwd->pw_passwd;
		      if (*lpass == '*') 
			lpass++;
		      pwd->pw_passwd=lpass;
		      break;
 	    case '?': usage();
	  }



	  // Write the new passwd file :)
	  while(fgets(foo2,255,passfile)) {
	    if (!strncmp(foo2,p,strlen(p))) {
	      if(putpwent(pwd,npass) <0) {
                printf("Could not get new entry written. EXITING");
		endpwent();
		fclose(passfile);
		unlink("/etc/ptmp");
		exit(-1);
	      }
            }
	    else {
	      if (fputs(foo2,npass) <0) {
                puts("Could not write ENTRIES into new passwd file. EXITING");
		fclose(passfile);
		fclose(npass);
		unlink("/etc/ptmp");
		exit(-1);
	      }
            }
	  }

	  // Close all the files
	  fclose(passfile);
	  fclose(npass);

	  // Practice safe sex and all while getting the job done
	  if (unlink("/etc/passwd.OLD")<0)
	    fprintf(stderr,"Could not get rid of old passwd file\n");
	  if (link("/etc/passwd","/etc/passwd.OLD") <0)
	    fprintf(stderr,"Could not keep OLD copy of passwd\n");
	  if (unlink("/etc/passwd")<0)
	    fprintf(stderr,"Old passwd file not deleted, no change\n");
	  if (link("/etc/ptmp","/etc/passwd")<0)
	    fprintf(stderr,"Could not write new passwd entry, no change\n");
	  if (unlink("/etc/ptmp") < 0)
	    fprintf(stderr,"Could not delete /etc/ptmp, still exists\n");

	  // get rid of our pointers and all
	  free(pass);
	  free(pwd->pw_passwd);
	  printf("Done.\n");
}

void usage ()
{  printf("usage: usermod [-f FullName] [-h home-dir] [-p] [-s shell] [-u username] user\n");
  exit(1);
}
