/*		Usermod version 1.1
 *		The C++ version ...
 *		Why C++ ?
 *		  - I can play wif pointers better 
 *		  - Less core dumps ...
 *		  - Much more clever (so I hear)
 *		  - See the C version *grynne*
 *
 *						Siviwe Kwatsha 03/Jul/96
 */

#include <unistd.h>
#include <pwd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

void usage(); // Is *THAT* what a prototype is ???

main (int argc, char **argv)
{	int ch;
	struct passwd *pwd;
	FILE *passfile, *npass;
	uid_t uid=getuid();

//------------------------------------------------------------------------------
//                        Are we stuck up or WHAT?
//------------------------------------------------------------------------------
	if (uid)
	  puts("\t\tONLY ROOT is allowed to modify user attributes ... \n\t\t\t\t\tSiviwe\'s usermod (ver 1.0)\n");

	pwd = getpwnam(argv[argc-1]);
	if (pwd == NULL)  {
	  usage();
	  exit(1);
	}

//------------------------------------------------------------------------------
//                          Open files
//------------------------------------------------------------------------------
	if ((passfile=fopen("/etc/passwd","r"))==NULL) {
	  printf("Could not open passwd file\n Write failed !\n");
	  exit(-1);
	}
	if ((npass=fopen("/etc/ptmp","w"))==NULL) {
	  printf("Could not open temp file\n Write failed !\n");
	  exit(-1);
	}
//------------------------------------------------------------------------------
//				NB
// These 2 lines *HAVE* to be here or slightly lower ... they find the ORIGINAL
// entry in the password so it can be replaced with the new !!! 
//------------------------------------------------------------------------------
	  char *p=new char [256];        // Stupid way to find entry ... BUT 
	  sprintf(p,"%s:",pwd->pw_name); // I never claimed to be clever

/* You may wonder why my variables are here ...
   Reason is I like them close to home ...
   Since they dont allow me to put them wif case ... here is close nuff */

//-----------------------------------------------------------------------------
//                Stupid program .. obey your master !
//-----------------------------------------------------------------------------
	char *foo,          //  These 2 variables are used in
	     *namethingie,  //  GECOS changing
	     *home,         //  Changing the home directory
	     *command=new char[256],
                            //  Actual command executed when changing home
	     *pass,         //  Password text
	     *username=new char[9],     //  New username
             *lpass; // To unlock password

	while ((ch=getopt(argc, argv, "f:h:ps:u:l")) != EOF)
	  switch(ch) {
	    case 'f': foo=optarg;
		      namethingie=strchr(pwd->pw_gecos,',');
		      if (namethingie != NULL) { // Do we have commas ?
			strcat(foo,namethingie);
		      }
		      pwd->pw_gecos=foo;
		      break;

	    case 'h': home=optarg;
		      sprintf(command,"mv --verbose %s %s", pwd->pw_dir, home);
		      pwd->pw_dir=home;
		      system(command);
		      break;

	    case 'p': pass = getpass("New Passwd : ");
		      pwd->pw_passwd=crypt(pass,pwd->pw_passwd);
		      delete pass; // Safety first ?
		      break; // Simple nuff for ya ?

            case 's': pwd->pw_shell=optarg;
		      break;

	    case 'u': username=optarg;
		      if ((getpwnam(username))==NULL) 
		        pwd->pw_name=username;
		      else {
			printf("That username already taken, choose another\n");
			exit(-1);
		      }
		      break;

	    case 'l': lpass=pwd->pw_passwd;
		      if (*lpass == '*')
			lpass++;
		      pwd->pw_passwd = lpass;
		      break;
 	    case '?': usage();
	    default : usage();
	  }

//------------------------------------------------------------------------------
//                   Write the new passwd file :)
//------------------------------------------------------------------------------

	  char *foo2=new char[256];
	  while(fgets(foo2,255,passfile)) {
	    if (!strncmp(foo2,p,strlen(p))) {
	      if(putpwent(pwd,npass) <0) {
                printf("Could not get new entry written. EXITING");
		endpwent();
		fclose(passfile);
		unlink("/etc/ptmp");
		exit(-1);
	      }
            }
	    else {
	      if (fputs(foo2,npass) <0) {
                puts("Could not write ENTRIES into new passwd file. EXITING");
		fclose(passfile);
		fclose(npass);
		unlink("/etc/ptmp");
		exit(-1);
	      }
            }
	  }

//------------------------------------------------------------------------------
//                         Close all the files
//------------------------------------------------------------------------------
	  fclose(passfile);
	  fclose(npass);
 
	  delete foo2; // Are we saving memory ???

//----------------------------------------------------------------------------- 
//            Practice safe sex and all while getting the job done
//-----------------------------------------------------------------------------
	  if (unlink("/etc/passwd.OLD")<0)
	    fprintf(stderr,"Could not get rid of old passwd file\n");
	  if (link("/etc/passwd","/etc/passwd.OLD") <0)
	    fprintf(stderr,"Could not keep OLD copy of passwd\n");
	  if (unlink("/etc/passwd")<0)
	    fprintf(stderr,"Old passwd file not deleted, no change\n");
	  if (link("/etc/ptmp","/etc/passwd")<0)
	    fprintf(stderr,"Could not write new passwd entry, no change\n");
	  if (unlink("/etc/ptmp") < 0)
	    fprintf(stderr,"Could not delete /etc/ptmp, still exists\n");

	  printf("Done.\n");

}

//------------------------------------------------------------------------------
//                          Tell Em
//------------------------------------------------------------------------------
void usage ()
{  printf("usage: usermod [-f FullName] [-h home-dir] [-p] [-s shell] [-u username] user\n");
  exit(1);
}
